app/urls.py
"""
URL Configuration
"""
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from qa.views import IndexView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('api/', include('api.urls')),
    path('qa/', include('qa.urls')),
    path('', IndexView.as_view(), name="index"),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

qa/urls.py
from django.urls import path

from . import views

app_name = 'qa'
urlpatterns = [
    path('ask', views.ask_view, name='ask'),
    path('<int:question_id>/', views.QuestionView.as_view(), name='question'),
    path('<int:question_id>/vote/', views.vote, name='vote'),
    path('answer/<int:answer_id>/vote/', views.vote_answer, name='vote_answer'),
    path('answer/<int:answer_id>/', views.correct_answer, name='correct_answer'),
    path('', views.SearchView.as_view(), name='search')
]

users/urls.py
from django.urls import path
from . import views

app_name = 'user'
urlpatterns = [
    path("", views.profile_view, name="profile"),
    path("register", views.register_request, name="register"),
    path("login", views.login_request, name="login"),
    path("logout", views.logout_request, name="logout"),
]

templates/base.html
{% extends 'bootstrap.html' %}
{% load bootstrap5 %}


{% block bootstrap5_content %}
    <div class="container">
        {% include "navbar.html" %}
        <div class="d-flex">
            {% include "sidebar.html" %}

            <div class="container py-3">
                <h1>{% block title %}{% endblock %}</h1>
                {% autoescape off %}{% bootstrap_messages %}{% endautoescape %}
                {% block content %}(no content){% endblock %}
            </div>
        </div>
    </div>

{% endblock %}

templates/bootstrap.html
{% extends 'bootstrap5/bootstrap5.html' %}

{% block bootstrap5_title %}{% block title %}{% endblock %}{% endblock %}

templates/navbar.html
{% load static %}

<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container-fluid">
        <a class="navbar-brand" href="{% url 'index' %}">
            <img src="{% static "images/qa.svg" %}" height="50" alt="QA">
        </a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                data-bs-target="#navbarSupportedContent"
                aria-controls="navbarSupportedContent" aria-expanded="false"
                aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <form class="d-flex w-100" action="{% url 'qa:search' %}">
                <input class="form-control me-2" type="search" name="search" placeholder="Поиск..."
                    {% if request.GET.search %}value="{{ request.GET.search }}" {% endif %}
                    aria-label="Search">
                <button class="btn btn-warning" type="submit">Найти</button>
            </form>
        </div>

        <div class="dropdown p-2">
            {% if user.is_authenticated %}
                <a href="#" class="d-flex align-items-center link-dark text-decoration-none dropdown-toggle" id="dropdownUser2" data-bs-toggle="dropdown" aria-expanded="false">
                    {% if user.profile.avatar %}
                        <img src="{{ user.profile.avatar.url }}" width="48" height="48" class="rounded-circle me-3" alt="{{ user.username }}">
                    {% else %}
                        <img src="/files/avatar.svg" width="48" height="48" class="rounded-circle me-3" alt="{{ user.username }}">
                    {% endif %}
                    <strong>{{ user.username|title }}</strong>
                </a>
                <ul class="dropdown-menu text-small shadow"
                    aria-labelledby="dropdownUser2">
                    <li><a class="dropdown-item" href="{% url 'qa:ask' %}">Задать вопрос</a></li>
                    <li><a class="dropdown-item" href="{% url 'user:profile' %}">Профиль</a></li>
                    <li><hr class="dropdown-divider"></li>
                    <li><a class="dropdown-item" href="{% url 'user:logout' %}">Выйти</a></li>
                </ul>
            {% else %}
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                  <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a href="{% url 'user:login' %}" class="nav-link link-dark">
                            <svg class="bi me-2" width="16" height="16">
                                <use xlink:href="#login"></use>
                            </svg>
                            Вход
                        </a>
                    </li>
                    <li class="nav-item">
                        <a href="{% url 'user:register' %}" class="nav-link link-dark">
                            <svg class="bi me-2" width="16" height="16">
                                <use xlink:href="#register"></use>
                            </svg>
                            Регистрация
                        </a>
                    </li>
                  </ul>
                </div>
            {% endif %}

        </div>
    </div>
</nav>

templates/sidebar.html
{% load static %}
{% load bootstrap5 %}

<svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
  <symbol id="ask" viewBox="0 0 16 16"><path d="M10.94 7.53h-5.5a.55.55 0 0 0 0 1.1h5.5a.55.55 0 0 0 0-1.1Zm0-2.19h-5.5a.55.55 0 0 0 0 1.1h5.5a.55.55 0 0 0 0-1.1ZM8.2 9.73H5.43a.55.55 0 0 0 0 1.1H8.2a.55.55 0 0 0 0-1.1Z"/><path d="M14.83 11.97a7.68 7.68 0 1 0-3.2 3l3.6.8a.55.55 0 0 0 .63-.71zm-1.12.1.8 2.41-2.84-.63a.54.54 0 0 0-.37.06 6.63 6.63 0 1 1 2.47-2.3.55.55 0 0 0-.06.46z"/></symbol>
  <symbol id="register" viewBox="0 0 16 16"><path d="M7.51 8a3.72 3.72 0 1 0 0-7.45 3.72 3.72 0 0 0 0 7.44zm0-6.39a2.66 2.66 0 1 1 0 5.32 2.66 2.66 0 0 1 0-5.32zm7.68 10.64h-1.6v-1.6a.53.53 0 1 0-1.06 0v1.6h-1.6a.53.53 0 1 0 0 1.06h1.6v1.6a.53.53 0 0 0 1.06 0v-1.6h1.6a.53.53 0 0 0 0-1.06z"/><path d="M10.93 14.37h-8.5a.55.55 0 0 1-.44-.23.48.48 0 0 1-.07-.43 5.85 5.85 0 0 1 5.6-4.02c1.1 0 2.19.31 3.13.9a.53.53 0 0 0 .56-.9 6.99 6.99 0 0 0-10.3 3.69c-.16.47-.08.99.22 1.39.3.42.79.66 1.3.67h8.5a.53.53 0 0 0 0-1.07z"/></symbol>
  <symbol id="login" viewBox="0 0 16 16"><path d="M8.04 7.98a3.75 3.75 0 1 0 0-7.49 3.75 3.75 0 0 0 0 7.5zm0-6.42a2.68 2.68 0 1 1 0 5.35 2.68 2.68 0 0 1 0-5.35zM14.7 13.4a6.95 6.95 0 0 0-6.65-4.77A6.95 6.95 0 0 0 1.4 13.4c-.16.47-.07 1 .22 1.4.3.42.8.66 1.31.67h10.23a1.6 1.6 0 0 0 1.53-2.07zm-1.1.78a.55.55 0 0 1-.44.23H2.93a.55.55 0 0 1-.44-.23.48.48 0 0 1-.08-.44 5.94 5.94 0 0 1 11.27 0 .5.5 0 0 1-.08.44z"/></symbol>
</svg>

<div class="d-flex flex-column flex-shrink-0 p-3" style="width: 280px;">
    {% bootstrap_button '<i class="bi"><svg class="me-2" width="20" height="20"><use xlink:href="#ask"></use></svg></i>Хочу спросить!' size='lg' button_class='btn btn-warning' href='/qa/ask' %}
    <hr>
    <h3>Популярные вопросы</h3>
    {% for question in trending %}
        <a href="{% url "qa:question" question.id %}" class="btn btn-outline-secondary position-relative my-2 text-start">
            {{ question.title }}
            <span class="position-absolute top-50 end-0 translate-middle badge bg-dark">{{ question.score }}</span>
        </a>
    {% endfor %}
</div>

templates/swagger.html
<!DOCTYPE html>
<html>
  <head>
    <title>Swagger</title>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" type="text/css" href="//unpkg.com/swagger-ui-dist@4/swagger-ui.css" />
  </head>
  <body>
    <div id="swagger-ui"></div>
    <script src="//unpkg.com/swagger-ui-dist@4/swagger-ui-bundle.js"></script>
    <script src="//unpkg.com/swagger-ui-dist@4/swagger-ui-standalone-preset.js" crossorigin></script>
    <script>
    const ui = SwaggerUIBundle({
        url: "{% url schema_url %}",
        dom_id: '#swagger-ui',
        presets: [
          SwaggerUIBundle.presets.apis,
          SwaggerUIStandalonePreset
        ],
        layout: "BaseLayout",
        requestInterceptor: (request) => {
          request.headers['X-CSRFToken'] = "{{ csrf_token }}"
          return request;
        }
      })
    </script>
  </body>
</html>